<?php
/*
Plugin Name: Auto Header Generator
Plugin URI: http://www.de-mas.net/autoheader-wordpress-plugin/
Description: This plugin generates META TAGS (title, description, keywords and robots) and the page title and put into your header, avoidding duplicate content and supplemental results.
Author: Eduard Fernandez
Version: 1.2
Author URI: http://www.eduardfernandez.com/
*/ 

/*
Copyright 2007 Eduard Fernandez (eduardmail@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function generate_metas() 
{
	global $post;
	/* 
	- is_home() -
	- is_single() -
	- is_page() -
	- is_category() -
	is_author()
	- is_date() -
	is_archive()
	- is_search() -
	is_404() 
	is_paged()
	- is_tag() -
	*/

	/* Recogiendo la informacin para llenar las variables */
	$the_title=strip_tags(get_option('blogname')); /* Titulo del blog */
	$the_title_single=strip_tags(the_title('','',FALSE)); /* Titulo del post */
	$the_descripcion=strip_tags(get_option('blogdescription')); /* Descripcion del blog */
	
	$description_excerpt = str_replace(array("\r\n", "\r", "\n", "  "), " ", $post->post_content); 
    $description_excerpt = str_replace(array("\""), "", $description_excerpt); 
	$description_excerpt = trim(substr(stripslashes(strip_tags($description_excerpt)),0,150))."...";
	//if (strlen(category_description() > 0))
	//{
	if (is_category()) {
		$the_category_description=strip_tags(category_description()); /* Descripcin de la categora ... */
	} else {
		$cat = get_the_category(); 
		$cat = $cat[0];
		$the_category_description=strip_tags($cat->category_description); /* Descripcin de la categoria ... */
		if (!($the_category_description))
		{
			$the_category_description=$the_descripcion; /* o la descripcin del blog para usarla como la de la categora */
			$description_excerpt = str_replace(array("\r\n", "\r", "\n", "  "), " ", $post->post_content); 
			$description_excerpt = str_replace(array("\""), "", $description_excerpt); 
			$description_excerpt = trim(substr(stripslashes(strip_tags($description_excerpt)),0,150))."...";
		}
	}

	if (single_cat_title('',FALSE))
	{
		$the_category_title=strip_tags(single_cat_title('',FALSE)); /* Titulo de la categora ... */
	} else {
		$cat = get_the_category(); 
		$cat = $cat[0];
		$the_category_title=strip_tags($cat->cat_name); /* Titulo de la categora ... */
		if (!($the_category_title))
		{
			$the_category_title=$the_title; /* o titulo del blog para usarlo como el de la categora */
		}
	}

	/* Palabras que no son necesario que aparezcan como keywords */
	$stop_words = array("-", "_", "/", ";", ".", ", ", "  ", ":", "<", ">", "'", "|","!","?","", "(", ")");
	$dic_stop_words = array("but", "down", "for", "out", "over", "per", "from", "like", "till", "with", "above", "the", "that", "this", "these", "then", "ante", "con", "desde", "entre", "es", "hacia", "hasta", "para", "por", "que", "sin", "tras", "los", "las", "unos", "unas","uno", "una", "del");
	
	/* Keywords que deben de aparecer en todas las pginas */
	$the_kw[]="blog";
	$the_kw[]="weblog";
	$the_keywords="blog, weblog";

	if (is_home())
	{
		$categories = get_categories(); 
		$all_cats = "";
		foreach ($categories as $cat) {
			$all_cats .= $cat->category_nicename." ";
		} 

		$all_cats = strtolower(rtrim($all_cats, " ,"));

		$line=$the_title." ".$all_cats;
		$line=strtolower($line);
		$line = str_replace($stop_words, " ", $line);
		$trozos = explode(" ", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (!(in_array ($trozo, $dic_stop_words)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_descripcion."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_title - $the_descripcion</title>", $header);
		print($header);
	}

	if (is_single())
	{
		if (isset($description_excerpt) && (strlen($description_excerpt) > 10)) 
		{
			$the_category_description=$description_excerpt;
			$the_category_description=str_replace("\n", " ", $the_category_description);
		} else {
			$the_category_description=$the_title_single.". ".$the_category_description;
		}
		
		$p = get_query_var('p');
		$posttags = get_the_tags($post);
		if ($posttags){
			foreach($posttags as $tag) {
				echo $tag->name;
				$tag=strtolower(trim($tag->name));
				if (!(in_array ($tag, $the_kw)))
				{
					$the_kw[]=$tag;
					$the_keywords.=", ".$tag;
				}
			}
		}
		$categories = get_the_category($p); 
		if ($categories){
			foreach ($categories as $cat) {
				$tagcat=strtolower(trim($cat->category_nicename));
				if (!(in_array ($tagcat, $the_kw)))
				{
					$the_kw[]=$tagcat;
					$the_keywords.=", ".$tagcat;
				}
			} 
		}
		$line=$the_title_single." ".$the_category_description;
		$line=strtolower($line);
		$line = str_replace($stop_words, " ", $line);
		$trozos = explode(" ", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (!(in_array ($trozo, $dic_stop_words)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_title_single."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_category_description."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_title_single</title>", $header);
		print($header);
	}

	if (is_page())
	{
		if (isset($description_excerpt) && (strlen($description_excerpt) > 10)) 
		{
			$the_descripcion=$description_excerpt;
			$the_descripcion=str_replace("\n", " ", $the_descripcion);
		} else {
			$the_descripcion=$the_title_single." - ".$the_descripcion;
		}

		$line=$the_title_single." ".$the_title." ".$the_descripcion;
		$line=strtolower($line);
		$line = str_replace($stop_words, " ", $line);
		$trozos = explode(" ", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (!(in_array ($trozo, $dic_stop_words)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_title_single." - ".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_descripcion."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_title_single - $the_title</title>", $header);
		print($header);
	}
		
	if (is_category())
	{
		$line=$the_category_title." ".$the_title." ".$the_category_description;
		$line=strtolower($line);
		$line = str_replace($stop_words, " ", $line);
		$trozos = explode(" ", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (!(in_array ($trozo, $dic_stop_words)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_category_title." - ".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_category_title." - ".$the_category_description."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_category_title - $the_title</title>", $header);
		print($header);
	}

	if (is_date())
	{
		$line=$the_title." ".$the_descripcion;
		$line=strtolower($line);
		$line = str_replace($stop_words, " ", $line);
		$trozos = explode(" ", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (!(in_array ($trozo, $dic_stop_words)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
		}
		/* Metas */
		$the_wp_version=get_bloginfo('version');
		$the_wp_version = str_replace(".", "", $the_wp_version);
		if ($the_wp_version<210)
		{
			//$my_month = single_month_title(' ', true);
			global $m, $monthnum, $month, $year;
			if ( !empty($monthnum) && !empty($year) ) {
				$my_year = $year;
				$my_month = $month[str_pad($monthnum, 2, '0', STR_PAD_LEFT)];
			} elseif ( !empty($m) ) {
				$my_year = substr($m, 0, 4);
				$my_month = $month[substr($m, 4, 2)];
			} else {
				$my_year = " Date";
				$my_month = "No";
			}
			$title_date=$my_month." ".$my_year;
			echo "<meta name=\"title\" content=\"".$title_date." - ".$the_title."\" />\n";
			echo "<meta name=\"description\" content=\"".$title_date." - ".$the_descripcion."\" />\n";
			echo "<meta name=\"keywords\" content=\"".$my_month.", ".$my_year.", ".$the_keywords."\" />\n";
			$header = ob_get_contents();
			ob_end_clean();
			$header = preg_replace("/<title>.*<\/title>/", "<title>$title_date - $the_title</title>", $header);
			print($header);
		} else {
			$title_date=trim(single_month_title(' ', false));
			echo "<meta name=\"title\" content=\"".$title_date." - ".$the_title."\" />\n";
			echo "<meta name=\"description\" content=\"".$title_date." - ".$the_descripcion."\" />\n";
			echo "<meta name=\"keywords\" content=\"".$title_date.", ".$the_keywords."\" />\n";
			$header = ob_get_contents();
			ob_end_clean();
			$header = preg_replace("/<title>.*<\/title>/", "<title>".$title_date." - $the_title</title>", $header);
			print($header);
		}
	}
	
	if (is_tag())
	{
		$tag_title=single_tag_title("", false);
		$line=$tag_title." ".$the_title." ".$the_descripcion;
		$the_kw[]=$tag_title;
		$the_keywords=$the_keywords.", ".$tag_title;
		$line=strtolower($line);
		$line = str_replace($stop_words, " ", $line);
		$trozos = explode(" ", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (!(in_array ($trozo, $dic_stop_words)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$tag_title." - ".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$tag_title." - ".$the_title." - ".$the_descripcion."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$tag_title - $the_title</title>", $header);
		print($header);
		$utw3check=0;
	}

	if (is_search())
	{
		global $s;
		$search_kw=wp_specialchars($s);
		$line=$search_kw." ".$the_title." ".$the_descripcion;
		$line=strtolower($line);
		$line = str_replace($stop_words, " ", $line);
		$trozos = explode(" ", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (!(in_array ($trozo, $dic_stop_words)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$search_kw." - ".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$search_kw." - ".$the_descripcion."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$search_kw - $the_title</title>", $header);
		print($header);
	}

	if(!is_home() && !is_single() && !is_page() && !is_category() && !is_tag() && !is_search()) 
	{
		echo "<meta name=\"robots\" content=\"noindex,follow\" />\n";
	} else {
		echo "<meta name=\"robots\" content=\"index,follow\" />\n";
	}
}

function start() {
	ob_start();
}
add_action('wp_head','generate_metas');
start();	
?>